<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Tree Node Lists</TITLE>
<link href="suif1_21.html" rel=Next>
<link href="suif1_19.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_19.html">previous</A>, <A HREF="suif1_21.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC20" HREF="suif1_toc.html#TOC20">Tree Node Lists</A></H2>
<P>
<A NAME="IDX118"></A>

</P>
<P>
<A NAME="IDX119"></A>
<A NAME="IDX120"></A>
<A NAME="IDX121"></A>
A <CODE>tree_node_list</CODE> is a doubly-linked list of tree nodes, derived
from the <CODE>dlist</CODE> class.  See section <A HREF="suif1_95.html#SEC95">Doubly-Linked Lists</A>.  Most nodes in
an AST have their children recorded in tree node lists.  For example,
the body of a block node is a tree node list.  Besides the standard list
features, each tree node list includes a back-pointer to its parent tree
node.  These pointers are maintained automatically by the SUIF library
and can be accessed using the <CODE>parent</CODE> method.  In addition, each
node on a tree node list contains pointers back to the list and the list
element.  See section <A HREF="suif1_13.html#SEC13">Other Features Shared by All Tree Nodes</A>.  These pointers are set by the
<CODE>set_elem</CODE> method (see section <A HREF="suif1_92.html#SEC92">Generic Lists</A>) which is automatically
called every time an element is added to the list.

</P>
<P>
<A NAME="IDX122"></A>
<A NAME="IDX123"></A>
<A NAME="IDX124"></A>
<A NAME="IDX125"></A>
In a <CODE>tree_for</CODE> node, the lower bound, upper bound, and step value
are usually treated as operands; however, the operands are actually
stored as tree node lists.  See section <A HREF="suif1_17.html#SEC17">For Nodes</A>.  Each of these lists is
required to contain a single expression with a dummy copy instruction at
the root.  The destination of the dummy copy must be a null operand.
The <CODE>tree_node_list</CODE> class includes several methods to handle these
special lists.  The <CODE>is_op</CODE> method checks if the list consists of a
single copy instruction with a null destination.  The <CODE>op</CODE> method
retrieves the operand stored in the list.  If after converting the list
to expression tree form, the <CODE>is_op</CODE> method returns <CODE>TRUE</CODE>,
the <CODE>op</CODE> method returns the source operand of the dummy copy
instruction; otherwise, an error occurs.  The <CODE>set_op</CODE> method is
used to set the contents of the tree node list to a dummy copy
instruction with the specified operand as its source.  The list must
either be empty or already contain the dummy copy.  Finally, the
<CODE>op_is_intconst</CODE> method checks if the operand in the tree node list
is a constant integer, and if so, returns the value.

</P>
<P>
<A NAME="IDX126"></A>
<A NAME="IDX127"></A>
Tree node lists can easily be printed out as text.  The <CODE>print</CODE>
method simply iterates through the list and calls the <CODE>print</CODE>
method for each tree node.  The optional <CODE>depth</CODE> parameter
specifies the indentation level to be used.  A separate method is used
to print tree node lists that hold <CODE>tree_for</CODE> operands.  If the
<CODE>is_op</CODE> method for one of these lists returns <CODE>TRUE</CODE>, the
<CODE>print_expr</CODE> method prints the operand directly.  Otherwise, it
prints the list as usual.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_19.html">previous</A>, <A HREF="suif1_21.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
